clear all
close all

load CamData

Cams{1}=C1;
Cams{2}=C2;
Cams{3}=C3;
qs{1}=q1;
qs{2}=q2;
qs{3}=q3;
Q0=LinCamTri(Cams,qs)


% X0=Q0;
% [f,J]=CamTri(X0,Cams,qs);
% numJ=zeros(size(J));
% delta=1e-7;
% for i=1:size(J,2),
%     dX0=X0; dX0(i)=dX0(i)+delta;
%     numJ(:,i)=(CamTri(dX0,Cams,qs)-f)/delta;
% end
% norm(J-numJ)/norm(J+numJ)
% return

Y=-1:0.02:1;
Z=-1:0.02:1;
Out=zeros(length(Y),length(Z));
for cy=1:length(Y),
    for cz=1:length(Z),
        Q=[0 Y(cy) Z(cz) 1]';
        f=CamTri(Q,Cams,qs);
        Out(cy,cz)=f'*f;
    end
end

imagesc(Y,Z,Out)
axis image

opts=[1e-3 1e-4 1e-8 1e2 1e-14];
[Q, info,perf] = marquardt('CamTri', Q0,opts,Cams,qs);
hold on
plot(Q(2,:)./Q(4,:),Q(3,:)./Q(4,:),'*-k')
hold off
figure
plot(log(perf(1,:)))




