function [f,J]=CamTri(Q,Cams,qs)

nObs=length(Cams);
f=zeros(nObs*2,1);
J=zeros(nObs*2,4);

for cObs=1:nObs,
    Cam=Cams{cObs};
    p=Cam*Q;
    f(cObs*2-1) =p(1)/p(3)-qs{cObs}(1)/qs{cObs}(3);
    f(cObs*2)   =p(2)/p(3)-qs{cObs}(2)/qs{cObs}(3);
    J(cObs*2-1,:)=(p(3)*Cam(1,:)-p(1)*Cam(3,:))/(p(3)*p(3));
    J(cObs*2,:)=(p(3)*Cam(2,:)-p(2)*Cam(3,:))/(p(3)*p(3));
end





